## NMSettingIP6Config

NMSettingIP6Config — Describes IPv6 addressing, routing, and name service properties

## Functions

NMSetting * | nm_setting_ip6_config_new ()
NMSettingIP6ConfigPrivacy | nm_setting_ip6_config_get_ip6_privacy ()
NMSettingIP6ConfigAddrGenMode | nm_setting_ip6_config_get_addr_gen_mode ()
const char * | nm_setting_ip6_config_get_token ()

## Properties

gint | addr-gen-mode | Read / Write / Construct
NMSettingIP6ConfigPrivacy | ip6-privacy | Read / Write / Construct
gchar * | token | Read / Write

## Types and Values

#define | NM_SETTING_IP6_CONFIG_SETTING_NAME
#define | NM_SETTING_IP6_CONFIG_IP6_PRIVACY
#define | NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE
#define | NM_SETTING_IP6_CONFIG_TOKEN
#define | NM_SETTING_IP6_CONFIG_METHOD_IGNORE
#define | NM_SETTING_IP6_CONFIG_METHOD_AUTO
#define | NM_SETTING_IP6_CONFIG_METHOD_DHCP
#define | NM_SETTING_IP6_CONFIG_METHOD_LINK_LOCAL
#define | NM_SETTING_IP6_CONFIG_METHOD_MANUAL
#define | NM_SETTING_IP6_CONFIG_METHOD_SHARED
enum | NMSettingIP6ConfigPrivacy
enum | NMSettingIP6ConfigAddrGenMode
| NMSettingIP6Config

## Object Hierarchy

        GEnum
        ├── NMSettingIP6ConfigAddrGenMode
        ╰── NMSettingIP6ConfigPrivacy
        GObject
        ╰── NMSetting
            ╰── NMSettingIPConfig
                ╰── NMSettingIP6Config

## Description

The NMSettingIP6Config object is a NMSetting subclass that describes properties related to IPv6 addressing, routing, and Domain Name Service

NMSettingIP6Config has few properties or methods of its own; it inherits almost everything from NMSettingIPConfig.

NetworkManager supports 6 values for the “method” property for IPv6. If "auto" is specified then the appropriate automatic method (PPP, router advertisement, etc) is used for the device and most other properties can be left unset. To force the use of DHCP only, specify "dhcp"; this method is only valid for Ethernet- based hardware. If "link-local" is specified, then an IPv6 link-local address will be assigned to the interface. If "manual" is specified, static IP addressing is used and at least one IP address must be given in the "addresses" property. If "ignore" is specified, IPv6 configuration is not done. Note: the "shared" method is not yet supported.

## Functions

### nm_setting_ip6_config_new ()

    NMSetting *
    nm_setting_ip6_config_new (void);

Creates a new NMSettingIP6Config object with default values.

#### Returns

the new empty NMSettingIP6Config object.

[transfer full]

### nm_setting_ip6_config_get_ip6_privacy ()

    NMSettingIP6ConfigPrivacy
    nm_setting_ip6_config_get_ip6_privacy (NMSettingIP6Config *setting);

Returns the value contained in the “ip6-privacy” property.

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

IPv6 Privacy Extensions configuration value (NMSettingIP6ConfigPrivacy).

### nm_setting_ip6_config_get_addr_gen_mode ()

    NMSettingIP6ConfigAddrGenMode
    nm_setting_ip6_config_get_addr_gen_mode
                                   (NMSettingIP6Config *setting);

Returns the value contained in the “addr-gen-mode” property.

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

IPv6 Address Generation Mode.

Since: 1.2

### nm_setting_ip6_config_get_token ()

    const char *
    nm_setting_ip6_config_get_token (NMSettingIP6Config *setting);

Returns the value contained in the “token” property.

#### Parameters

setting | the NMSettingIP6Config |

#### Returns

A string.

Since: 1.4

## Types and Values

### NM_SETTING_IP6_CONFIG_SETTING_NAME

    #define NM_SETTING_IP6_CONFIG_SETTING_NAME "ipv6"

### NM_SETTING_IP6_CONFIG_IP6_PRIVACY

    #define NM_SETTING_IP6_CONFIG_IP6_PRIVACY "ip6-privacy"

### NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE

    #define NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE "addr-gen-mode"

### NM_SETTING_IP6_CONFIG_TOKEN

    #define NM_SETTING_IP6_CONFIG_TOKEN "token"

### NM_SETTING_IP6_CONFIG_METHOD_IGNORE

    #define NM_SETTING_IP6_CONFIG_METHOD_IGNORE     "ignore"

IPv6 is not required or is handled by some other mechanism, and NetworkManager should not configure IPv6 for this connection.

### NM_SETTING_IP6_CONFIG_METHOD_AUTO

    #define NM_SETTING_IP6_CONFIG_METHOD_AUTO       "auto"

IPv6 configuration should be automatically determined via a method appropriate for the hardware interface, ie router advertisements, DHCP, or PPP or some other device-specific manner.

### NM_SETTING_IP6_CONFIG_METHOD_DHCP

    #define NM_SETTING_IP6_CONFIG_METHOD_DHCP       "dhcp"

IPv6 configuration should be automatically determined via DHCPv6 only and router advertisements should be ignored.

### NM_SETTING_IP6_CONFIG_METHOD_LINK_LOCAL

    #define NM_SETTING_IP6_CONFIG_METHOD_LINK_LOCAL "link-local"

IPv6 configuration should be automatically configured for link-local-only operation.

### NM_SETTING_IP6_CONFIG_METHOD_MANUAL

    #define NM_SETTING_IP6_CONFIG_METHOD_MANUAL     "manual"

All necessary IPv6 configuration (addresses, prefix, DNS, etc) is specified in the setting's properties.

### NM_SETTING_IP6_CONFIG_METHOD_SHARED

    #define NM_SETTING_IP6_CONFIG_METHOD_SHARED     "shared"

This connection specifies configuration that allows other computers to connect through it to the default network (usually the Internet). The connection's interface will be assigned a private address, and router advertisements, a caching DNS server, and Network Address Translation (NAT) functionality will be started on this connection's interface to allow other devices to connect through that interface to the default network. (not yet supported for IPv6)

### enum NMSettingIP6ConfigPrivacy

NMSettingIP6ConfigPrivacy values indicate if and how IPv6 Privacy Extensions are used (RFC4941).

#### Members

NM_SETTING_IP6_CONFIG_PRIVACY_UNKNOWN | unknown or no value specified |
NM_SETTING_IP6_CONFIG_PRIVACY_DISABLED | IPv6 Privacy Extensions are disabled |
NM_SETTING_IP6_CONFIG_PRIVACY_PREFER_PUBLIC_ADDR | IPv6 Privacy Extensions are enabled, but public addresses are preferred over temporary addresses |
NM_SETTING_IP6_CONFIG_PRIVACY_PREFER_TEMP_ADDR | IPv6 Privacy Extensions are enabled and temporary addresses are preferred over public addresses |

### enum NMSettingIP6ConfigAddrGenMode

NMSettingIP6ConfigAddrGenMode controls how the the Interface Identifier for RFC4862 Stateless Address Autoconfiguration is created.

#### Members

NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE_EUI64 | The Interface Identifier is derived from the interface hardware address. |
NM_SETTING_IP6_CONFIG_ADDR_GEN_MODE_STABLE_PRIVACY | The Interface Identifier is created by using a cryptographically secure hash of a secret host-specific key along with the connection identification and the network address as specified by RFC7217. |

Since: 1.2

### NMSettingIP6Config

    typedef struct _NMSettingIP6Config NMSettingIP6Config;

## Property Details

### The `“addr-gen-mode”` property

      “addr-gen-mode”            gint

Configure method for creating the address for use with RFC4862 IPv6 Stateless Address Autoconfiguration. The permitted values are: "eui64", or "stable-privacy".

If the property is set to "eui64", the addresses will be generated using the interface tokens derived from hardware address. This makes the host part of the address to stay constant, making it possible to track host's presence when it changes networks. The address changes when the interface hardware is replaced.

The value of "stable-privacy" enables use of cryptographically secure hash of a secret host-specific key along with the connection identification and the network address as specified by RFC7217. This makes it impossible to use the address track host's presence, and makes the address stable when the network interface hardware is replaced.

On D-Bus, the absence of an addr-gen-mode setting equals enabling "stable-privacy". For keyfile plugin, the absence of the setting on disk means "eui64" so that the property doesn't change on upgrade from older versions.

Note that this setting is distinct from the Privacy Extensions as configured by "ip6-privacy" property and it does not affect the temporary addresses configured with this option.

Flags: Read / Write / Construct

Default value: 1

Since: 1.2

### The `“ip6-privacy”` property

      “ip6-privacy”              NMSettingIP6ConfigPrivacy

Configure IPv6 Privacy Extensions for SLAAC, described in RFC4941. If enabled, it makes the kernel generate a temporary IPv6 address in addition to the public one generated from MAC address via modified EUI-64. This enhances privacy, but could cause problems in some applications, on the other hand. The permitted values are: -1: unknown, 0: disabled, 1: enabled (prefer public address), 2: enabled (prefer temporary addresses).

Having a per-connection setting set to "-1" (unknown) means fallback to global configuration "ipv6.ip6-privacy".

If also global configuration is unspecified or set to "-1", fallback to read "/proc/sys/net/ipv6/conf/default/use_tempaddr".

Note that this setting is distinct from the Stable Privacy addresses that can be enabled with the "addr-gen-mode" property's "stable-privacy" setting as another way of avoiding host tracking with IPv6 addresses.

Flags: Read / Write / Construct

Default value: NM_SETTING_IP6_CONFIG_PRIVACY_UNKNOWN

### The `“token”` property

      “token”                    gchar *

Configure the token for draft-chown-6man-tokenised-ipv6-identifiers-02 IPv6 tokenized interface identifiers. Useful with eui64 addr-gen-mode.

Flags: Read / Write

Default value: NULL

Since: 1.4